#
# TODO:
#	- patch our kernel to provide the needed API and update
#	  the dependencies here
#
# Conditional build:
%bcond_without	kernel		# don't build kernel modules
%bcond_without	userspace	# don't build userspace tools
%bcond_with	verbose		# verbose build (V=1)

# The goal here is to have main, userspace, package built once with
# simple release number, and only rebuild kernel packages with kernel
# version as part of release number, without the need to bump release
# with every kernel change.
%if 0%{?_pld_builder:1} && %{with kernel} && %{with userspace}
%{error:kernel and userspace cannot be built at the same time on PLD builders}
exit 1
%endif

%if %{without userspace}
# nothing to be placed to debuginfo package
%define		_enable_debug_packages	0
%endif

%define		rel	1
%define		pname	ipset
Summary:	IP sets utility
Summary(pl.UTF-8):	Narzędzie do zarządzania zbiorami IP
Name:		%{pname}%{?_pld_builder:%{?with_kernel:-kernel}}%{_alt_kernel}
Version:	7.4
Release:	%{rel}%{?_pld_builder:%{?with_kernel:@%{_kernel_ver_str}}}
License:	GPL v2
Group:		Networking/Admin
#Source0Download: http://ipset.netfilter.org/install.html
Source0:	http://ipset.netfilter.org/%{pname}-%{version}.tar.bz2
# Source0-md5:	f9dda6f2fc3bb941e0ca3a6c292baf2c
Source1:	%{pname}.init
URL:		http://ipset.netfilter.org/
BuildRequires:	autoconf >= 2.50
BuildRequires:	automake
BuildRequires:	libmnl-devel >= 1
BuildRequires:	libltdl-devel >= 2:2.0
BuildRequires:	libtool >= 2:2.0
%{?with_userspace:BuildRequires:	linux-libc-headers >= 7:2.6.38.6}
BuildRequires:	pkgconfig
BuildRequires:	rpmbuild(macros) >= 1.701
%{?with_kernel:%{expand:%buildrequires_kernel kernel%%{_alt_kernel}-module-build >= 3:2.6.24}}
Suggests:	kernel-net-ipset
BuildRoot:	%{tmpdir}/%{name}-%{version}-root-%(id -u -n)

# unresolved ipset_errcode, defined in the ipset binary
%define		skip_post_check_so	libipset\.so.*

%description
IP sets are a framework inside the Linux 2.4.x and 2.6.x kernel, which
can be administered by the ipset utility. Depending on the type,
currently an IP set may store IP addresses, (TCP/UDP) port numbers or
IP addresses with MAC addresses in a way, which ensures lightning
speed when matching an entry against a set.

%description -l pl.UTF-8
Zbiory IP to szkielet w jądrze Linuksa 2.4.x i 2.6.x, którym można
administrować przy użyciu narzędzia ipset. W zależności od
rodzaju aktualnie zbiór IP może przechowywać adresy IP, numery
portów (TCP/UDP) lub adresy IP z adresami MAC - w sposób
zapewniający maksymalną szybkość przy dopasowywaniu elementu do
zbioru.

%package devel
Summary:	Header files for ipset interface
Summary(pl.UTF-8):	Pliki nagłówkowe do interfejsu ipset
Group:		Development/Libraries
Requires:	%{name} = %{version}-%{release}
Requires:	libmnl-devel >= 1

%description devel
Header files for IPset interface.

%description devel -l pl.UTF-8
Pliki nagłówkowe do interfejsu IPset.

%package static
Summary:	Static ipset interface library
Summary(pl.UTF-8):	Biblioteka statyczna interfejsu ipset
Group:		Development/Libraries
Requires:	%{name}-devel = %{version}-%{release}

%description static
Static IPset interface library.

%description static -l pl.UTF-8
Biblioteka statyczna interfejsu IPset.

%package init
Summary:	IPset init script
Summary(pl.UTF-8):	Skrypt startowy IPset
Group:		Networking/Admin
Requires(post,preun):	/sbin/chkconfig
Requires:	%{pname} = %{version}-%{release}
Requires:	rc-scripts

%description init
IPset initialization script.

%description init -l pl.UTF-8
Skrypt startowy IPset.

%package -n bash-completion-ipset
Summary:	Bash completion for ipset command
Summary(pl.UTF-8):	Bashowe dopełnianie parametrów polecenia ipset
Group:		Applications/Shells
Requires:	%{pname} = %{version}-%{release}
Requires:	bash-completion >= 2.0

%description -n bash-completion-ipset
Bash completion for ipset command.

%description -n bash-completion-ipset -l pl.UTF-8
Bashowe dopełnianie parametrów polecenia ipset.

%define	kernel_pkg()\
%package -n kernel%{_alt_kernel}-net-ipset\
Summary:	IPset kernel modules\
Summary(pl.UTF-8):	Moduły jądra oferujące wsparcie dla zbiorów IP\
Release:	%{rel}@%{_kernel_ver_str}\
Group:		Base/Kernel\
Requires(post,postun):	/sbin/depmod\
%requires_releq_kernel\
Requires(postun):	%releq_kernel\
\
%description -n kernel%{_alt_kernel}-net-ipset\
IP sets are a framework inside the Linux 2.4.x and 2.6.x kernel, which\
can be administered by the ipset utility. Depending on the type,\
currently an IP set may store IP addresses, (TCP/UDP) port numbers or\
IP addresses with MAC addresses in a way, which ensures lightning\
speed when matching an entry against a set.\
\
This package contains kernel modules.\
\
%description -n kernel%{_alt_kernel}-net-ipset -l pl.UTF-8\
Zbiory IP to szkielet w jądrze Linuksa 2.4.x i 2.6.x, którym można\
administrować przy użyciu narzędzia ipset. W zależności od\
rodzaju aktualnie zbiór IP może przechowywać adresy IP, numery\
portów (TCP/UDP) lub adresy IP z adresami MAC - w sposób\
zapewniający maksymalną szybkość przy dopasowywaniu elementu do\
zbioru.\
\
Ten pakiet zawiera moduły jądra oferujące wsparcie dla zbiorów IP.\
\
%if %{with kernel}\
%files -n kernel%{_alt_kernel}-net-ipset\
%defattr(644,root,root,755)\
/lib/modules/%{_kernel_ver}/kernel/net/ipv4/netfilter/xt_*.ko*\
%dir /lib/modules/%{_kernel_ver}/kernel/net/ipv4/netfilter/ipset\
/lib/modules/%{_kernel_ver}/kernel/net/ipv4/netfilter/ipset/ip_set.ko*\
/lib/modules/%{_kernel_ver}/kernel/net/ipv4/netfilter/ipset/ip_set_*.ko*\
%endif\
\
%post	-n kernel%{_alt_kernel}-net-ipset\
%depmod %{_kernel_ver}\
\
%postun	-n kernel%{_alt_kernel}-net-ipset\
%depmod %{_kernel_ver}\
%{nil}

%define build_kernel_pkg()\
%configure \\\
	--disable-silent-rules \\\
	--with-kmod=yes \\\
	--with-kbuild=%{_kernelsrcdir} \\\
	--with-settype-modules-list=all\
\
# a hack not to list all modules: list only ip_set, all other are build anyway\
%build_kernel_modules -C kernel/net/netfilter -m ipset/ip_set IP_SET_MAX=255 KDIR=$PWD/../..\
\
for drv in kernel/net/netfilter/ipset/ip_set*.ko ; do\
%install_kernel_modules -D installed -m ${drv%.ko} -d kernel/net/ipv4/netfilter/ipset\
done\
for drv in kernel/net/netfilter/xt_*.ko ; do\
%install_kernel_modules -D installed -m ${drv%.ko} -d kernel/net/ipv4/netfilter\
done\
%{nil}

%{?with_kernel:%{expand:%create_kernel_packages}}

%prep
%setup -q -n %{pname}-%{version}

%build
%{__aclocal}
%{__autoconf}
%{__autoheader}
%{__automake}
%if %{with userspace}
install -d build-usr
cd build-usr
../%configure \
	bashcompdir=%{bash_compdir} \
	--enable-bashcompl \
	--disable-silent-rules \
	--with-kmod=no \
	--with-settype-modules-list=all

%{__make}
cd ..
%endif

%{?with_kernel:%{expand:%build_kernel_packages}}

%install
rm -rf $RPM_BUILD_ROOT

%if %{with userspace}
install -d $RPM_BUILD_ROOT{/etc/rc.d/init.d,%{_includedir}/libipset}

%{__make} -C build-usr install \
	DESTDIR=$RPM_BUILD_ROOT

install -p %{SOURCE1} $RPM_BUILD_ROOT/etc/rc.d/init.d/%{pname}
%endif

%if %{with kernel}
install -d $RPM_BUILD_ROOT
cp -a installed/* $RPM_BUILD_ROOT
%endif

%clean
rm -rf $RPM_BUILD_ROOT

%post init
/sbin/chkconfig --add %{pname}

%preun init
if [ "$1" = "0" ]; then
	/sbin/chkconfig --del %{pname}
fi

%if %{with userspace}
%files
%defattr(644,root,root,755)
%doc ChangeLog ChangeLog.ippool README UPGRADE
%attr(755,root,root) %{_sbindir}/ipset
%attr(755,root,root) %{_libdir}/libipset.so.*.*.*
%attr(755,root,root) %ghost %{_libdir}/libipset.so.13
%{_mandir}/man3/libipset.3*
%{_mandir}/man8/ipset.8*

%files devel
%defattr(644,root,root,755)
%attr(755,root,root) %{_libdir}/libipset.so
%{_libdir}/libipset.la
%{_includedir}/libipset
%{_pkgconfigdir}/libipset.pc

%files static
%defattr(644,root,root,755)
%{_libdir}/libipset.a

%files init
%defattr(644,root,root,755)
%attr(754,root,root) /etc/rc.d/init.d/ipset

%files -n bash-completion-ipset
%defattr(644,root,root,755)
%{bash_compdir}/ipset
%endif
%changelog
* Sun Dec 22 2019 PLD Linux Team <feedback@pld-linux.org>
- For complete changelog see: http://git.pld-linux.org/?p=packages/ipset.git;a=log;h=auto/th/ipset-7.4-1

* Fri Nov 29 2019 Jakub Bogusz <qboosh@pld-linux.org> bce7a88
- updated to 7.4
- removed outdated kernel-5.* patches

* Thu Aug 01 2019 Adam Gołębiowski <adamg@pld-linux.org> 5e8a0f5
- updated to 7.3

* Thu Aug 01 2019 Adam Gołębiowski <adamg@pld-linux.org> abfa15b
- updated to 7.2

* Tue May 07 2019 Jan Rękorajski <baggins@pld-linux.org> 7ee29df
- fix building with kernel 5.1
- rel 2

* Mon Mar 11 2019 Jan Rękorajski <baggins@pld-linux.org> fee922c
- rel 1

* Sun Mar 10 2019 Jan Rękorajski <baggins@pld-linux.org> 6b10edb
- relax the test for netlink_ack

* Sun Mar 10 2019 Jan Rękorajski <baggins@pld-linux.org> 4fbe6bd
- fix building with kernel 5.0

* Sat Mar 09 2019 Jan Rękorajski <baggins@pld-linux.org> 036276e
- up to 7.1, doesn't build with kernel 5.0

* Mon Dec 03 2018 Arkadiusz Miśkiewicz <arekm@maven.pl> bddb98d
- rel 2; build fix

* Tue Nov 27 2018 Jakub Bogusz <qboosh@pld-linux.org> d2abbe0
- at least 2.6.24 headers are required according to configure

* Tue Nov 06 2018 Adam Gołębiowski <adamg@pld-linux.org> 21871c3
- updated to 7.0, new soname

* Mon Jun 18 2018 Jan Rękorajski <baggins@pld-linux.org> 40774c9
- up to 6.38

* Mon Jan 29 2018 Jan Rękorajski <baggins@pld-linux.org> 0bc1667
- updated so version
- rel 2

* Mon Jan 29 2018 Jan Rękorajski <baggins@pld-linux.org> b7e41ce
- up to 6.35

* Thu Nov 16 2017 Jan Rękorajski <baggins@pld-linux.org> b2e3f67
- up to 6.34

* Sat Sep 16 2017 Jan Rękorajski <baggins@pld-linux.org> 596472c
- up to 6.33

* Tue Aug 01 2017 Jan Rękorajski <baggins@pld-linux.org> 19f0432
- fix building with kernel 4.12
- rel 2

* Sat Mar 25 2017 Jan Rękorajski <baggins@pld-linux.org> 68e8d3c
- up to 6.32
- fix building with linux 4.10

* Wed Dec 14 2016 Jakub Bogusz <qboosh@pld-linux.org> 2405b15
- removed obsolete patch

* Wed Dec 14 2016 Jakub Bogusz <qboosh@pld-linux.org> ab2b172
- updated to 6.30
- package bash completion file

